# HG changeset patch
# User idxa<idxa@sina.com>
# Date 1383632411 -28800
#      Tue Nov 05 14:20:11 2013 +0800
# Node ID 3cb3cd448429ad95203ed176da4e5e1ec48a5f4e
# Parent  686b5b50279715bcfd15af8603e52c59de7d1b40
fix some bugs of slicetypeDecide() when param.bFrameAdaptive==0 or param.bframes==0.
1.update lastNonB,pic->m_lowres.leadingBframes and pic->m_lowres.bLastMiniGopBFrame when param.bFrameAdaptive==0 or param.bframes==0.
2.fix the bug of output order of lookahead outputQueue. For example, when "keyint=10, bframes=3, b-adapt=0", output frames "IPBBBPBBBPI..." instead of "IPBBBPBBBIP..."

diff -r 686b5b502797 -r 3cb3cd448429 source/encoder/slicetype.cpp
--- a/source/encoder/slicetype.cpp	Mon Nov 04 22:50:48 2013 -0600
+++ b/source/encoder/slicetype.cpp	Tue Nov 05 14:20:11 2013 +0800
@@ -703,6 +703,7 @@
             pic->m_lowres.bKeyframe = true;
             lastKeyframe = pic->m_lowres.frameNum;
         }
+        lastNonB = &pic->m_lowres;
         outputQueue.pushBack(*pic);
         numDecided++;
     }
@@ -719,7 +720,12 @@
                 pic->m_lowres.sliceType = X265_TYPE_I;
                 pic->m_lowres.bKeyframe = true;
                 lastKeyframe = pic->m_lowres.frameNum;
-                if (j) list[j - 1]->m_lowres.sliceType = X265_TYPE_P;
+                lastNonB = &pic->m_lowres;
+                if (j)
+                {
+                    list[j - 1]->m_lowres.sliceType = X265_TYPE_P;
+                    pic->m_lowres.leadingBframes = 0;
+                }
                 j++;
                 break;
             }
@@ -727,16 +733,44 @@
 
         TComPic *pic = list[j - 1];
         if (pic->m_lowres.sliceType == X265_TYPE_AUTO)
+        {
             pic->m_lowres.sliceType = X265_TYPE_P;
-        outputQueue.pushBack(*pic);
-        numDecided++;
-        for (int i = 0; i < j - 1; i++)
-        {
-            pic = list[i];
-            if (pic->m_lowres.sliceType == X265_TYPE_AUTO)
-                pic->m_lowres.sliceType = X265_TYPE_B;
+            pic->m_lowres.leadingBframes = j - 1;
+            lastNonB = &pic->m_lowres;
             outputQueue.pushBack(*pic);
             numDecided++;
+            int lastB = -1;
+            for (int i = 0; i < j - 1; i++)
+            {
+                pic = list[i];
+                if (pic->m_lowres.sliceType == X265_TYPE_AUTO)
+                {
+                    pic->m_lowres.sliceType = X265_TYPE_B;
+                    lastB = i;
+                }
+                
+                outputQueue.pushBack(*pic);
+                numDecided++;
+            }
+            if (lastB >= 0)
+            list[lastB]->m_lowres.bLastMiniGopBFrame = true;
+        }
+        else
+        {
+            int lastB = -1;
+            for (int i = 0; i <= j - 1; i++)
+            {
+                pic = list[i];
+                if (pic->m_lowres.sliceType == X265_TYPE_AUTO)
+                {
+                    pic->m_lowres.sliceType = X265_TYPE_B;
+                    lastB = i;
+                }
+                outputQueue.pushBack(*pic);
+                numDecided++;
+            }
+            if (lastB >= 0)
+                list[lastB]->m_lowres.bLastMiniGopBFrame = true;
         }
     }
 }
